# &adminguide;

## Overview

This module offers support for instant message conference using SIP MESSAGE requests. It follows the architecture of IRC channels. The conferences are managed by commands that can be sent embedded in the MESSAGE body, because there are just a few SIP UA implementations which have GUI for IM conferencing.

By sending a SIP MESSAGE a configured SIP URI to the IM conferencing manager, the user can send commands to manage conference rooms. Once the conference room is created, users can send commands directly to conference's URI.

To ease the integration in the configuration file, the interpreter of the IMC commands are embedded in the module. From a configuration point of view, there is only one function which has to be executed for both messages and commands.

## Dependencies

### &kamailio; Modules

The following modules must be loaded before this module:

- db_mysql.

- tm.

### External Libraries or Applications

The following libraries or applications must be installed before running &kamailio; with this module loaded:

- None.

## Parameters

### `db_url` (str)

The database url.

The default value is &defaultdb;.

#### Set `db_url` parameter

    ...
    modparam("imc", "db_url", "&exampledb;")
    ...

### `db_mode`(integer)

The module supports 2 modes of operation, high speed memory based storage (mode 0), and database only (mode 2) where all data is stored in a database, allowing scalability at the expense of speed. Mode 1 is reserved.

Default value is 0

#### Set `db_mode` parameter

    ...
    modparam("imc", "db_mode", 2)
    ...

### `rooms_table` (str)

The name of the table storing IMC rooms.

The default value is "imc_rooms".

#### Set `rooms_table` parameter

    ...
    modparam("imc", "rooms_table", "rooms")
    ...

### `members_table` (str)

The name of the table storing IMC members.

The default value is "imc_members".

#### Set `members_table` parameter

    ...
    modparam("imc", "members_table", "members")
    ...

### `hash_size` (integer)

The power of 2 to get the size of the hash table used for storing members and rooms.

The default value is 4 (resulting in hash size 16).

#### Set `hash_size` parameter

    ...
    modparam("imc", "hash_size", 8)
    ...

### `imc_cmd_start_char` (str)

The character which indicates that the body of the message is a command.

The default value is "#".

#### Set `imc_cmd_start_char` parameter

    ...
    modparam("imc", "imc_cmd_start_char", "#")
    ...

### `outbound_proxy` (str)

The SIP address used as next hop when sending the message. Very useful when using &kamailio; with a domain name not in DNS, or when using a separate &kamailio; instance for imc processing. If not set, the message will be sent to the address in destination URI.

Default value is NULL.

#### Set `outbound_proxy` parameter

    ...
    modparam("imc", "outbound_proxy", "sip:kamailio.org;transport=tcp")
    ...

### `extra_hdrs` (str)

Extra headers (each ending with \r\n) to be added in messages sent out from imc server.

Default value is NULL.

#### Set `extra_hdrs` parameter

    ...
    modparam("imc", "extra_hdrs", "P-Flags: 3\r\n")
    ...

### `create_on_join` (integer)

If set to 1 and user requests to join a non-existing room, the room will be automatically created. If set to 0, joining a non-existing room returns an error.

The default value is 1.

#### Set `create_on_join` parameter

    ...
    modparam("imc", "create_on_join", 0)
    ...

### `check_on_create` (integer)

If set to 1, the chat server will report an error if the user attempts to create a room that already exists.

The default value is 0.

#### Set `check_on_create` parameter

    ...
    modparam("imc", "check_on_create", 1)
    ...

## Functions

### `imc_manager()`

THis function handles incoming MESSAGE requests. If detects if the body of the message is a conference command it executes it, otherwise it sends the message to all the members in the room.

This function can be used from REQUEST_ROUTE. See command description for error codes returned by this function.

#### Usage of `imc_manager()` function

    ...
    # the rooms will be named chat-xyz to avoid overlapping
    # with usernames
    if(is_method("MESSAGE)
        && (uri=~ "sip:chat-[0-9]+@" || (uri=~ "sip:chat-manager@"))
    {
        if(imc_manager())
            sl_send_reply("200", "ok");
        else
            sl_send_reply("500", "command error");
        exit;
    }
    ...

### `imc_room_active(room)`

Return 1 (true) if the room is active, -1 (false) if the room is not found. The parameter is the SIP URI to identify the room, it can contain variables.

This function can be used from ANY_ROUTE.

#### Usage of `imc_room_active()` function

    ...
        if(imc_room_active("sip:chat-sip@$fd")) {
            ...
        }
    ...

### `imc_room_member(room, user)`

Return 1 (true) if the user is member of the room, -1 (false) if the user is not member of the room. The parameters are the SIP URIs to identify the room and the user, they can contain variables.

This function can be used from ANY_ROUTE.

#### Usage of `imc_room_member()` function

    ...
        if(imc_room_member("sip:chat-sip@$fd", "sip:$rU@$rd")) {
            ...
        }
    ...

## RPC Commands

### imc.list_rooms

Lists of the IM Conferencing rooms.

Name: imc.list_rooms

Parameters: none

RPC Command Format:

    ...
    &kamcmd; imc_list_rooms
    ...

### imc.list_members

Listing of the members in IM Conferencing rooms.

Name: imc.list_members

Parameters:

- _room_ : the room for which you want to list the members

RPC Command Format:

    ...
    &kamcmd; imc_list_members _room_
    ...

## Statistics

### `active_rooms`

Number of active IM Conferencing rooms.

## IMC Commands

A command is identified by the starting character. A command must be written in one line. By default, the starting character is '#'. You can change it via "imc_cmd_start_char" parameter.

Next picture presents the list of commands and their parameters.

### List of commands

    ...

    1.create
      -creates a conference room
      -takes 2 parameters:
         1) the name of the room
         2)optional- "private" -if present the created room is private
    	   and new members can be added only though invitations
      -the user is added as the first member and owner of the room
      -eg:  #create chat-000 private
      -error case: return codes: -30 -- -39

    2.join
      -makes the user member of a room
      -takes one optional parameter - the address of the room -if not
        present it will be considered to be the address in the To
        header of the message
      -if the room does not exist the command is treated as create
      -eg:join sip:chat-000@kamailio.org,
          or just, #join, sent to sip:chat-000@kamailio.org
      -error case: return codes: -40 -- -49

    3.invite
      -invites a user to become a member of a room
      -takes 2 parameters:
         1)the complete address of the user
         2)the address of the room -if not present it will be considered
    	   to be the address in the To header of the message
      -only certain users have the right to invite other user: the owner
        and the administrators
      -eg: #invite sip:john@kamailio.org sip:chat-000@kamailio.org
        or  #invite john@kamailio.org sent to sip:chat-000@kamailio.org
      -error case: return codes: -50 -- -59

    4.accept
      -accepting an invitation
      -takes one optional parameter - the address of the room - if not
        present it will be considered to be the address in the To header
        of the message
      -eg: #accept sip:john@kamailio.org
      -error case: return codes: -60 -- -69

    5.reject
      -rejects an invitation
      -the parameter is the same as for accept
      -error case: return codes: -70 -- -79

    6.remove
      -deletes a member from a room
      -takes 2 parameters:
        1)the complete address of the member
        2)the address of the room -if not present it will be considered
    	  to be the address in the To header of the message
      -only certain members have the right to remove other members
      -eg: #remove sip:john@kamailio.org, sent to sip:chat-000@kamailio.org
      -error case: return codes: -80 -- -89

    7.leave
      -leaving a room
      -takes one optional parameter - the address of the room - if not
        present it will be considered to be the address in the To header
        of the message
      -if the user is the owner of the room, the room will be destroyed
      -error case: return codes: -90 -- -99

    8.destroy
      -removing a room
      -the parameter is the same as for leave
      -only the owner of a room has the right to destroy it
      -error case: return codes: -110 -- -119

    9.members
      -list members in a room
      -error case: return codes: -100 -- -109

    10.add
      -adds a user to a room
      -takes 2 parameters:
         1)the complete address of the user
         2)the address of the room -if not present it will be considered
    	   to be the address in the To header of the message
      -only certain users have the right to add other users: the owner
        and the administrators
      -eg: #add sip:john@kamailio.org sip:chat-000@kamailio.org
        or  #add john@kamailio.org sent to sip:chat-000@kamailio.org
      -error case: return codes: -50 -- -59

    11.modify
      -modify user role in a room
      -takes 3 parameters:
         1)the complete address of the user
    	 2)the role of the user
         3)the address of the room -if not present it will be considered
    	   to be the address in the To header of the message
      -only certain users have the right to invite other user: the owner
        and the administrators
      -roles: owner, admin, member
      -eg: #invite sip:john@kamailio.org admin sip:chat-000@kamailio.org
        or  #invite john@kamailio.org admin sent to sip:chat-000@kamailio.org
      -error case: return codes: -120 -- -129
    ...

## Installation

Before running &kamailio; with IMC, you have to setup the database tables where the module will store the data. For that, if the tables were not created by the installation script or you choose to install everything by yourself you can use the imc-create.sql SQL script in the database directories in the kamailio/scripts folder as template. You can also find the complete database documentation on the project webpage, &kamailiodbdocslink;.